package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPUPDT_VariableContainer {
    public @Getter String WS_TRANS_ID = "OIUP";
    public @Getter String WS_MAPSET_NAME = "OIVPM05";
    public @Getter String WS_MAP_NAME = "OIVPM05";
    public @Getter @Setter int WS_RESPONSE_CODE;
    public @Getter String WS_COMMUNICATION_AREA = StringUtils.repeat(' ', 1);
    public @Getter @Setter int WS_FIRST_TIME_FLAG;
    public @Getter @Setter OIVPUPDT_WS_ERROR_MESSAGE WS_ERROR_MESSAGE = new OIVPUPDT_WS_ERROR_MESSAGE();
    public @Getter @Setter OIVPUPDT_OIVPM05I OIVPM05I = new OIVPUPDT_OIVPM05I();

    public OIVPUPDT_OIVPM05O getOIVPM05O() {
        return OIVPUPDT_OIVPM05O.builder().FILLER12(getFILLER12())
                .FILLER13(getFILLER13()).DATEO(getDATEO())
                .FILLER14(getFILLER14()).TERMO(getTERMO())
                .FILLER15(getFILLER15()).TIMEO(getTIMEO())
                .FILLER16(getFILLER16()).IDENO(getIDENO())
                .FILLER17(getFILLER17()).NAMEO(getNAMEO())
                .FILLER18(getFILLER18()).DEPTO(getDEPTO())
                .FILLER19(getFILLER19()).PHONO(getPHONO())
                .FILLER20(getFILLER20()).EMALO(getEMALO())
                .FILLER21(getFILLER21()).ADDRO(getADDRO())
                .FILLER22(getFILLER22()).MSGO(getMSGO()).build();
    }

    public void setOIVPM05O(String source) {
        setFILLER12(source.substring(0, 12));
        setFILLER13(source.substring(12, 15));
        setDATEO(source.substring(15, 23));
        setFILLER14(source.substring(23, 26));
        setTERMO(source.substring(26, 30));
        setFILLER15(source.substring(30, 33));
        setTIMEO(source.substring(33, 41));
        setFILLER16(source.substring(41, 44));
        setIDENO(source.substring(44, 52));
        setFILLER17(source.substring(52, 55));
        setNAMEO(source.substring(55, 95));
        setFILLER18(source.substring(95, 98));
        setDEPTO(source.substring(98, 138));
        setFILLER19(source.substring(138, 141));
        setPHONO(source.substring(141, 181));
        setFILLER20(source.substring(181, 184));
        setEMALO(source.substring(184, 224));
        setFILLER21(source.substring(224, 227));
        setADDRO(source.substring(227, 267));
        setFILLER22(source.substring(267, 270));
        setMSGO(source.substring(270, 346));
    }

    public void setOIVPM05O(OIVPUPDT_OIVPM05O source) {
        setOIVPM05O(source.toString());
    }

    public String getFILLER12() {
        return getOIVPM05I().getFILLER1();
    }

    public void setFILLER12(String source) {
        OIVPM05I.setFILLER1(source);
    }

    public String getFILLER13() {
        return String.valueOf(getOIVPM05I().getDATEL())
                + getOIVPM05I().getDATEF();
    }

    public void setFILLER13(String source) {
        OIVPM05I.setDATEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setDATEF(source.substring(2));
    }

    public String getDATEO() {
        return getOIVPM05I().getDATEI();
    }

    public void setDATEO(String source) {
        OIVPM05I.setDATEI(source);
    }

    public String getFILLER14() {
        return String.valueOf(getOIVPM05I().getTERML())
                + getOIVPM05I().getTERMF();
    }

    public void setFILLER14(String source) {
        OIVPM05I.setTERML(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setTERMF(source.substring(2));
    }

    public String getTERMO() {
        return getOIVPM05I().getTERMI();
    }

    public void setTERMO(String source) {
        OIVPM05I.setTERMI(source);
    }

    public String getFILLER15() {
        return String.valueOf(getOIVPM05I().getTIMEL())
                + getOIVPM05I().getTIMEF();
    }

    public void setFILLER15(String source) {
        OIVPM05I.setTIMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setTIMEF(source.substring(2));
    }

    public String getTIMEO() {
        return getOIVPM05I().getTIMEI();
    }

    public void setTIMEO(String source) {
        OIVPM05I.setTIMEI(source);
    }

    public String getFILLER16() {
        return String.valueOf(getOIVPM05I().getIDENL())
                + getOIVPM05I().getIDENF();
    }

    public void setFILLER16(String source) {
        OIVPM05I.setIDENL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setIDENF(source.substring(2));
    }

    public String getIDENO() {
        return getOIVPM05I().getIDENI();
    }

    public void setIDENO(String source) {
        OIVPM05I.setIDENI(source);
    }

    public String getFILLER17() {
        return String.valueOf(getOIVPM05I().getNAMEL())
                + getOIVPM05I().getNAMEF();
    }

    public void setFILLER17(String source) {
        OIVPM05I.setNAMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setNAMEF(source.substring(2));
    }

    public String getNAMEO() {
        return getOIVPM05I().getNAMEI();
    }

    public void setNAMEO(String source) {
        OIVPM05I.setNAMEI(source);
    }

    public String getFILLER18() {
        return String.valueOf(getOIVPM05I().getDEPTL())
                + getOIVPM05I().getDEPTF();
    }

    public void setFILLER18(String source) {
        OIVPM05I.setDEPTL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setDEPTF(source.substring(2));
    }

    public String getDEPTO() {
        return getOIVPM05I().getDEPTI();
    }

    public void setDEPTO(String source) {
        OIVPM05I.setDEPTI(source);
    }

    public String getFILLER19() {
        return String.valueOf(getOIVPM05I().getPHONL())
                + getOIVPM05I().getPHONF();
    }

    public void setFILLER19(String source) {
        OIVPM05I.setPHONL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setPHONF(source.substring(2));
    }

    public String getPHONO() {
        return getOIVPM05I().getPHONI();
    }

    public void setPHONO(String source) {
        OIVPM05I.setPHONI(source);
    }

    public String getFILLER20() {
        return String.valueOf(getOIVPM05I().getEMALL())
                + getOIVPM05I().getEMALF();
    }

    public void setFILLER20(String source) {
        OIVPM05I.setEMALL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setEMALF(source.substring(2));
    }

    public String getEMALO() {
        return getOIVPM05I().getEMALI();
    }

    public void setEMALO(String source) {
        OIVPM05I.setEMALI(source);
    }

    public String getFILLER21() {
        return String.valueOf(getOIVPM05I().getADDRL())
                + getOIVPM05I().getADDRF();
    }

    public void setFILLER21(String source) {
        OIVPM05I.setADDRL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setADDRF(source.substring(2));
    }

    public String getADDRO() {
        return getOIVPM05I().getADDRI();
    }

    public void setADDRO(String source) {
        OIVPM05I.setADDRI(source);
    }

    public String getFILLER22() {
        return String.valueOf(getOIVPM05I().getMSGL())
                + getOIVPM05I().getMSGF();
    }

    public void setFILLER22(String source) {
        OIVPM05I.setMSGL(Integer.parseInt(source.substring(0, 2)));
        OIVPM05I.setMSGF(source.substring(2));
    }

    public String getMSGO() {
        return getOIVPM05I().getMSGI();
    }

    public void setMSGO(String source) {
        OIVPM05I.setMSGI(source);
    }

    public @Getter String DEFINITIONS_OF_EIBAID_FIELD = StringUtils.repeat(' ',
            1);
    public @Getter @Setter OIVPUPDT_WS_DATE_TIME_AREA WS_DATE_TIME_AREA = new OIVPUPDT_WS_DATE_TIME_AREA();
    public @Getter String FILE01 = "OIVPFILE";
    public @Getter String TSQ01 = "OIVPTSQ";
    public @Getter @Setter int ITEM01 = 1;
    public @Getter @Setter int LEN = 4;
    public @Getter @Setter int LEN1 = 8;
    public @Getter @Setter int TOK;
    public @Getter @Setter int DATALEN = 104;
    public @Getter @Setter OIVPUPDT_PEOPLE_INFO PEOPLE_INFO = new OIVPUPDT_PEOPLE_INFO();
    public @Getter @Setter OIVPUPDT_PEOPLE_INFO_TEMP PEOPLE_INFO_TEMP = new OIVPUPDT_PEOPLE_INFO_TEMP();
    public @Getter String START_CODE = StringUtils.repeat(' ', 2);
    public @Getter String DFHCOMMAREA = StringUtils.repeat(' ', 1);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setWS_TRANS_ID(String source) {
        WS_TRANS_ID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setWS_MAPSET_NAME(String source) {
        WS_MAPSET_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7),
                7);
    }

    public void setWS_MAP_NAME(String source) {
        WS_MAP_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public String getStringWS_RESPONSE_CODE() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE, "00000000");
    }

    public void setWS_COMMUNICATION_AREA(String source) {
        WS_COMMUNICATION_AREA = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public String getStringWS_FIRST_TIME_FLAG() {
        return intFormatWithSign.apply((long) WS_FIRST_TIME_FLAG, "0000");
    }

    public void setDEFINITIONS_OF_EIBAID_FIELD(String source) {
        DEFINITIONS_OF_EIBAID_FIELD = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setFILE01(String source) {
        FILE01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setTSQ01(String source) {
        TSQ01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringITEM01() {
        return intFormatWithSign.apply((long) ITEM01, "0000");
    }

    public String getStringLEN() {
        return intFormatWithSign.apply((long) LEN, "0000");
    }

    public String getStringLEN1() {
        return intFormatWithSign.apply((long) LEN1, "0000");
    }

    public String getStringTOK() {
        return intFormatWithSign.apply((long) TOK, "00000000");
    }

    public String getStringDATALEN() {
        return intFormatWithSign.apply((long) DATALEN, "0000");
    }

    public void setSTART_CODE(String source) {
        START_CODE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setDFHCOMMAREA(String source) {
        DFHCOMMAREA = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }
}
